#include "wrttmp.h"

typedef char bool;	/* Boolean type */
#define TRUE    1
#define FALSE   0

#define LBSIZE 1024	/* Size of the input line buffer */

#ifndef ANSWER_TEL
#define ANSWER_TEL 240	/* seconds after tel during which writes are OK */
#endif

/* ======================== GLOBAL VARIABLES =========================== */

extern bool no_file, char_by_char, ask_root, fixed_modes, in_cbreak, is_writing,
	    insys, telegram, no_switch, am_root, rec_only, postpone;
extern char tmp_mesg;
extern char *progname, *mytty, *version, *telmsg;
extern char myname[], hisname[], mydevname[], hisdevname[], histty[], linebuf[];
extern char myuidname[];
extern FILE *histerm;
extern int wstream;
extern long hispos,mypos;

/* ========================= GLOBAL DEFINES ============================ */

/* Unix Version Dependent defines */

#ifdef SYSIII
#define F_TERMIO		/* use ioctl() to set modes */
#define RAND() rand()
#define MAXRAND 32767
#define SEEDRAND(x) srand(x)
#endif /*SYSIII*/

#ifdef SYSV
#define F_TERMIO		/* use ioctl() to set modes */
#define RAND() rand()
#define MAXRAND 32767		/* probably wrong! */
#define SEEDRAND(x) srand(x)
#endif /*SYSV*/

#ifdef BSD
#ifdef linux
#define F_TERMIOS		/* use tcsetattr() to set modes */
#else
#define F_STTY			/* use stty() to set modes */
#endif
#define JOB_CONTROL		/* support job-control */
#define RAND() random()
#define MAXRAND 2147483647
#define SEEDRAND(x) srandom(x)
#endif /*BSD*/

#define USER_SHELL

/* These are the tty modes to use when permissions are on and off */

#define PERMS_OFF 0600		/* To depermit everything */
#define PERMS_OPEN 0622		/* To allow cats to your device */
#ifdef TTY_OTHERS
#define PERMS_ON  PERMS_OPEN	/* To allow writes and talks and what not */
#else
#define PERMS_ON  0620		/* To allow writes and talks and what not */
#endif /*TTY_OTHERS*/

/* =================== PROCEDURE DEFINITIONS ===-----================== */

char *rindex(), *ttyname(), *ctime(), *getenv(), *index();
time_t time();

/* wrt_him.c functions */
void find_us(void);
bool iswritable(void);
bool he_replied(void);

/* wrt_hist.c functions */
void open_hist(void);
bool may_answer_tel(void);
int check_flood(void);
void register_tel(void);

/* wrt_main.c functions */
void done(int code);

/* wrt_me.c functions */
void find_me(void);
void set_modes(void);
void reset_modes(void);
bool nested_write(void);
bool checktty(char *devname);
void init_lastmesg(void);
void show_lastmesg(void);

/* wrt_opt.c functions */
char *leafname(char *fullpath);
void default_opts(char *argname);
void user_opts(int argc, char **argv);

/* wrt_sig.c functions */
void siginit(void);
void sigoff(void);
void intr(int sig);
void susp(void);
void dosystem(char *cmd);

/* wrt_tty.c functions */
void cbreak(bool flag);
void flushinput(int dev);
int get_cols(void);

/* wrt_type.c functions */
void dowrite(void);
void dotelegram(bool nl);
void open_record(void);
#ifdef EXCEPTIONS
int ishisexception(int yesfile, char *login);
int isuexception(char *user, int yesfile, char *login);
#endif
